///////////////////////////////////////////////////////////////////////////
//                                                                       //
// Copyright (c) 1997 ISO/IEC All Rights Reserved                        //
//                                                                       //
// This software module was developed by                                 //
//                                                                       //
// CSELT (Centro Studi e Laboratori Telecomunicazioni S.p.A)             //
//                                                                       //
// in the course of development of the MPEG-4 standard. This software    //
// module is an implementation of a part of one or more MPEG-4 tools as  //
// specified by the MPEG-4 standard.                                     //
//                                                                       //
// The copyright of this software belongs to ISO/IEC. ISO/IEC gives use  //
// of the MPEG-4 standard free license to use this  software module or   //
// modifications thereof for hardware or software products claiming      //
// conformance to the MPEG-4 standard.                                   //
//                                                                       //
// Those intending to use this software module in hardware or software   //
// products are advised that use may infringe existing  patents. The     //
// original developers of this software module and their companies, the  //
// subsequent editors and their companies, and ISO/IEC have no liability //
// and ISO/IEC have no liability for use of this software module or      //
// modification thereof in an implementation.                            //
//                                                                       //
///////////////////////////////////////////////////////////////////////////
//
// File: DmifPeer.h
//
// Authors: Nuno Delgado, CSELT
//
// Description:
//
///////////////////////////////////////////////////////////////////////////


#ifndef _DMIFPEER_H
#define _DMIFPEER_H

// Prevent inclusion of winsock.h in windows.h
#ifndef _WINSOCKAPI_
#define _WINSOCKAPI_
#endif
#include "winsock2.h"
#include "Dai.h"
#include "DaiSession.h"
#include "ztl.h"

class Dai;
class DaiSession;

struct FmcStruct
{
	unsigned int mChannelAssocTag, mFlexMuxChannelNumber, mTransMuxAssocTag;
    
	BOOL operator == (const struct FmcStruct &rElement) const
    {
			if((mChannelAssocTag == rElement.mChannelAssocTag) && 
				(mFlexMuxChannelNumber == rElement.mFlexMuxChannelNumber) &&
				 (mTransMuxAssocTag == rElement.mTransMuxAssocTag))
				return TRUE;
			else
				return FALSE;
    }
};


typedef ZArray<struct FmcStruct> FMC;



class CDmifPeer
{

	private:
		FMC mFmcTable;
		Dai* m_pDai;
		DaiSession* m_pSession;
		WSAEVENT m_hEvent;		  // The event that will activated by this socket
		WSAEVENT m_hControlEvent; // An event for terminate the thread

	public:
		char* m_pDmifPeerAddress;     // The address of the dmif peer
		SOCKET m_hDmifCtrlSock;      // The DmifControl channel associated with this peer
		unsigned int m_ServiceId;
		WSAEVENT m_EventArray[2];
		DWORD m_NumEvents;

		CDmifPeer();
		CDmifPeer(Dai*, DaiSession*);
		~CDmifPeer();

		void AddElementToFmcTable(unsigned int,unsigned int,unsigned int);
		BOOL FindElementInFmcTable(unsigned int, unsigned int&, unsigned int&);
		BOOL AssociateSocketWithEvent();
		void FillDaiAndDaiSessionInfo(Dai*, DaiSession*);
};
#endif