#ifndef _h263dec_h
#define _h263dec_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       H263Dec.h
AUTHOR:     Karl Anders ygard (Telenor R&D)
OVERVIEW:   Definition of H263Decoder
-------------------------------------------------------------------------*/

#include "Decoder.h"
#include "../H263Decoder/H263.h"

class H263Decoder : public Decoder
{
	virtual FORMAT SetFormat (Capabilities *pPresentationCapabilities);
	virtual int GetOptimalInputSize () {return 256;}
	virtual int GetOptimalOutputSize ();
	virtual int GetRecommendedInputBufferSize () {return 2000;}
	virtual int GetRecommendedOutputBufferSize () {return GetOptimalOutputSize() * 4;}
	virtual BOOL Decode (
		LPBYTE pInput,
		int nInputLength,
		LPBYTE pOutput,
		int &rnOutputLength
	);
        H263Dec m_decoder;

public:
	H263Decoder (class Executive *pExecutive) : Decoder (pExecutive) {}
};

#endif


// Emacs uses these...
// Local Variables:
// mode: c++
// tab-width: 4
// End:
