#if !defined(_h263dec_h)	// Sentry, use file only if it's not already included.
#define _h263dec_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       H263GDec.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Definition of H263Decoder (simulation)
-------------------------------------------------------------------------*/
#include "Decoder.h"
#include "DecInstW.h"
#include "declib.h"

class H263Decoder : public Decoder
{
	virtual FORMAT SetFormat (Capabilities *pPresentationCapabilities);
	virtual int GetOptimalInputSize () {return 4000;}
	virtual int GetOptimalOutputSize ();
	virtual int GetRecommendedInputBufferSize () {return 16000;}
	virtual int GetRecommendedOutputBufferSize () {return 600000;}
	virtual BOOL Decode (
		LPBYTE pInput,
		int nInputLength,
		LPBYTE pOutput,
		int &rnOutputLength
	);
	TDecodeObject m_decodeObject;
	BITMAPINFOHEADER m_biDst, m_biSrc;
	LPBYTE tempOutput;		//ML added these
	int tempOutputSize;

public:
	H263Decoder (class Executive *pExecutive) : Decoder (pExecutive)
	{	//ML added this
		tempOutputSize = GetOptimalOutputSize();
		tempOutput = (unsigned char*)malloc(tempOutputSize);
	}

	//ML added this
	~H263Decoder()
	{ free(tempOutput); }
};

#endif                                      // _h263dec_h sentry.
