#ifndef _jpegdec_h
#define _jpegdec_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       JPEGDec.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Definition of JPEGDecoder (simulation)
-------------------------------------------------------------------------*/
#include "Decoder.h"
#include "Caps.h"

class JPEGDecoder : public Decoder
{
public:
	virtual FORMAT SetFormat (Capabilities *pPresentationCapabilities);
	virtual int GetOptimalInputSize () ;
	virtual int GetOptimalOutputSize () ;
	virtual int GetRecommendedInputBufferSize () ;
	virtual int GetRecommendedOutputBufferSize () ;
	virtual BOOL Decode (
		LPBYTE pInput,
		int nInputLength,
		LPBYTE pOutput,
		int &rnOutputLength
	);

public:
	JPEGDecoder (class Executive *pExecutive) : Decoder (pExecutive) {}
};

#endif // _jpegdec_h
