// MPEG4PlayerView.cpp : implementation of the CMPEG4PlayerView class
//

#include "defs.h"
#include "Im1defs.h"
#include "trace.h"
#include "Presenter-CSELT.h"
#include "MPEG4Player.h"
#include "MPEG4PlayerDoc.h"
#include "MPEG4PlayerView.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView

IMPLEMENT_DYNCREATE(CMPEG4PlayerView, CView)

BEGIN_MESSAGE_MAP(CMPEG4PlayerView, CView)
	//{{AFX_MSG_MAP(CMPEG4PlayerView)
	ON_WM_MOUSEMOVE()
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_MESSAGE(WM_SCENE_FINISHED, OnSceneFinished)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView construction/destruction

CMPEG4PlayerView::CMPEG4PlayerView()
{
	// TODO: add construction code here

}

CMPEG4PlayerView::~CMPEG4PlayerView()
{
}

BOOL CMPEG4PlayerView::PreCreateWindow(CREATESTRUCT& cs)
{

	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView drawing

void CMPEG4PlayerView::OnDraw(CDC* /*pDC*/)
{
	CMPEG4PlayerDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);

	TRACE_PRINT("In CMPEG4PlayerView::OnDraw():\n");

	// At this stage I'll redraw the entire window, rather than just
	// that part which has changed
	GetApp()->GetExecutive()->Paint(NULL);
} /* CMPEG4PlayerView::OnDraw */

/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView diagnostics

#ifdef _DEBUG
void CMPEG4PlayerView::AssertValid() const
{
	CView::AssertValid();
}

void CMPEG4PlayerView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CMPEG4PlayerDoc* CMPEG4PlayerView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CMPEG4PlayerDoc)));
	return (CMPEG4PlayerDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMPEG4PlayerView message handlers

void CMPEG4PlayerView::OnInitialUpdate() 
{
	CView::OnInitialUpdate();

	// The first time that this is called, the Executive needs to
	// be created
	if (GetApp()->GetExecutive() == NULL)
		GetApp()->CreateExecutive(m_hWnd);
}

/////////////////////////////////////////////////////////////////////////////

void CMPEG4PlayerView::OnMouseMove(UINT nFlags, CPoint point) 
{
	// Determine if the CTRL and/or the SHIFT keys are pressed
	UINT ctrlKeys = 0;
	if (nFlags & MK_CONTROL)
		ctrlKeys |= CK_CONTROL;
	if (nFlags & MK_SHIFT)
		ctrlKeys |= CK_SHIFT;

	// Pass this message onto the executive
	GetApp()->GetExecutive()->OnUserEvent(EVENT_MOUSE_MOVE,
										  point.x, point.y,
										  ctrlKeys);
} /* CMPEG4PlayerView::OnMouseMove */

/////////////////////////////////////////////////////////////////////////////


void CMPEG4PlayerView::OnLButtonDown(UINT nFlags, CPoint point) 
{
	// Determine if the CTRL and/or the SHIFT keys are pressed
	UINT ctrlKeys = 0;
	if (nFlags & MK_CONTROL)
		ctrlKeys |= CK_CONTROL;
	if (nFlags & MK_SHIFT)
		ctrlKeys |= CK_SHIFT;

	// Pass this message onto the executive
	GetApp()->GetExecutive()->OnUserEvent(EVENT_MOUSE_DOWN,
										  point.x, point.y,
										  ctrlKeys);
} /* CMPEG4PlayerView::OnLButtonDown */


/////////////////////////////////////////////////////////////////////////////

void CMPEG4PlayerView::OnLButtonUp(UINT nFlags, CPoint point) 
{
	// Determine if the CTRL and/or the SHIFT keys are pressed
	UINT ctrlKeys = 0;
	if (nFlags & MK_CONTROL)
		ctrlKeys |= CK_CONTROL;
	if (nFlags & MK_SHIFT)
		ctrlKeys |= CK_SHIFT;

	// Pass this message onto the executive
	GetApp()->GetExecutive()->OnUserEvent(EVENT_MOUSE_UP,
										  point.x, point.y,
										  ctrlKeys);
} /* CMPEG4PlayerView::OnLButtonUp */


/////////////////////////////////////////////////////////////////////////////

//
// CMPEG4PlayerView::OnSceneFinished
//
// Call the OnSceneFinished() member in the application.
//

LONG CMPEG4PlayerView::OnSceneFinished(WPARAM /*wParam*/, LPARAM /*lParam*/)
{
	GetApp()->OnSceneFinished();
	return 0;
} /* CMPEG4PlayerView::OnSceneFinished */


/////////////////////////////////////////////////////////////////////////////
