///////////////////////////////////////////////////////////////////////////
//                                                                       //
// Copyright (c) 1997 ISO/IEC All Rights Reserved                        //
//                                                                       //
// This software module was developed by                                 //
//                                                                       //
// CSELT (Centro Studi e Laboratori Telecomunicazioni S.p.A)             //
//                                                                       //
// in the course of development of the MPEG-4 standard. This software    //
// module is an implementation of a part of one or more MPEG-4 tools as  //
// specified by the MPEG-4 standard.                                     //
//                                                                       //
// The copyright of this software belongs to ISO/IEC. ISO/IEC gives use  //
// of the MPEG-4 standard free license to use this  software module or   //
// modifications thereof for hardware or software products claiming      //
// conformance to the MPEG-4 standard.                                   //
//                                                                       //
// Those intending to use this software module in hardware or software   //
// products are advised that use may infringe existing  patents. The     //
// original developers of this software module and their companies, the  //
// subsequent editors and their companies, and ISO/IEC have no liability //
// and ISO/IEC have no liability for use of this software module or      //
// modification thereof in an implementation.                            //
//                                                                       //
///////////////////////////////////////////////////////////////////////////
//
// File: Remote.h
//
// Authors: Nuno Delgado, CSELT
//
// Description:
//   RemoteService header file.
//
///////////////////////////////////////////////////////////////////////////


#ifndef _RemoteService_h
#define _RemoteService_h


// Prevent inclusion of winsock.h in windows.h
#ifndef _WINSOCKAPI_
#define _WINSOCKAPI_
#endif
#include <windows.h>

#include "Service.h"
#include "AL.h"
#include "Dai.h"
#include "fmt.h"


class Dai;
struct DATA;

class RemoteService : public Service
{
	
	private:
		ALManager* m_pALMan;
		unsigned int mSessionId;
		char mPeerAddress[128];
		Dai* pDai;

	public:
		RemoteService();
		RemoteService(ALManager*);

		void Connect(LPCSTR);					
		void Close();
		void OnChannelOpen(HANDLE, SMT&);
		void OnDataReceived(HANDLE, LPBYTE, int);
		void OpenChannels(int,const int*);
		virtual void ChannelsReady(int, const int*);
};


#endif