#if !defined(_al_h)	// Sentry, use file only if it's not already included.
#define _al_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Core
FILE:       AL.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Definition of ALManager
-------------------------------------------------------------------------*/
#include "Im1defs.h"
#include "ztl.h"

class Executive;
class MediaStream;
class DataChannel;
class StreamConsumer;

class ALManager
{
	Executive *m_pExecutive;
	StreamConsumer *m_pObject;
	ZArray<DataChannel *> m_channels;
	ZArray<int> m_ids;	

public:
	ALManager (Executive *pExecutive) : m_pExecutive (pExecutive) {}
	ALManager (StreamConsumer *pObject) :
		m_pExecutive (NULL),
		m_pObject (pObject)
	{}
	DataChannel *AttachStream (
		int nESid,
		MediaStream *pStream,
		ESCONFIGPARAMS *pConfigParams,
		int nExpectedAULength = 256
	);
	void RequestChannels ();
	Executive *GetExecutive () {return m_pExecutive;}
	void OnConnect (CONNECTION_RESULT result = CONNECTION_SUCCESS);
	DataChannel *OnChannelOpen (int nESid, int nTag);
	void OnFinish  (SERVICE_TERMINATION reason = END_OF_SERVICE);
};

#endif                                      // _al_h sentry.