// -*- c++ -*-

#if !defined(_NodeIDs_h)	// Sentry, use file only if it's not already included.
#define _NodeIDs_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS Decoder
FILE:       NodeIDs.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Node IDs values
-------------------------------------------------------------------------*/
enum MediaObjectTypes
{
/*	MO_QUANTIZATIONPARAMETER,   // new nodes
	MO_SWITCH,
	MO_WORLDINFO,
	MO_AUDIODELAY,
	MO_AUDIOMIX,
	MO_AUDIOSOURCE,
	MO_AUDIOTRANSFORM,
	MO_AUDIOSWITCH,
	MO_COLOR,
	MO_M4IMAGETEXTURE,
	MO_M4MOVIETEXTURE,
	MO_TEXTURECOORDINATE,
	MO_TEXTURETRANSFORM,
	MO_ANIMATIONSTREAM,
	MO_COLORINTERPOLATOR,
	MO_CONDITIONAL,
	MO_SCALARINTERPOLATOR,
	MO_TIMESENSOR,
	MO_TOUCHSENSOR,
	MO_GROUP2D,
	MO_INLINE2D,
	MO_LAYOUT,
	MO_LOD2D,
	MO_SCROLL,
	MO_TRANSFORM2D,
	MO_XLAYOUT,
	MO_APPEARENCE2D,
	MO_BACKGROUND2D,
	MO_CIRCLE,
	MO_COORDINATE2D,
	MO_CURVE2D,
	MO_FONTSTYLE2D,
	MO_IMAGE2D,
	MO_INDEXEDFACESET2D,
	MO_INDEXEDLINESET2D,
	MO_MATERIAL2D,
	MO_MOVIE2D,
	MO_POINTSET2D,
	MO_PROPERTIES2D,
	MO_RECTANGLE,
	MO_SHAPE2D,
	MO_SOUND2D,
	MO_STREAMINGTEXT,
	MO_TEXT2D,
	MO_POSITION2DINTERPOLATOR,
	MO_PROXIMITY2DSENSOR,
	MO_BILLBOARD,
	MO_GROUP,
	MO_INLINE,
	MO_LOD,
	MO_TRANSFORM,
	MO_APPEARANCE,
	MO_AMBIENTLIGHT,
	MO_BACKGROUND,
	MO_BOX,
	MO_CONE,
	MO_COORDINATE,
	MO_CYLINDER,
	MO_DIRECTIONALLIGHT,
	MO_ELEVATIONGRID,
	MO_EXTRUSION,
	MO_FONTSTYLE,
	MO_INDEXEDFACESET,
	MO_INDEXEDLINESET,
	MO_LISTENINGPOINT,
	MO_MATERIAL,
	MO_NORMAL,
	MO_POINTLIGHT,
	MO_POINTSET,
	MO_SHAPE,
	MO_SOUND,
	MO_SPHERE,
	MO_SPOTLIGHT,
	MO_VIEWPOINT,
	MO_COLLISION   

Old nodes:
*/

	MO_APPEARANCE = 9,
	MO_COLOR = 16,
	MO_IMAGETEXTURE = 28,
	MO_INDEXEDLINESET = 30,
	MO_MATERIAL = 33,
	MO_MOVIETEXTURE = 35,
	MO_POINTSET = 38,
	MO_SHAPE = 40,
	MO_SWITCH = 45,
	MO_TEXTURECOORDINATE = 47,
	MO_TEXTURETRANSFORM = 48,
	MO_WORLDINFO = 53,
	MO_A_2DBACKGROUND = 0,
	MO_A_2DCOORDINATE = 1,
	MO_A_2DGROUP = 2,
	MO_A_2DINLINE = 4,
	MO_A_2DLOD = 5,
	MO_A_2DTRANSFORM = 7,
	MO_BLINK = 58,
	MO_CIRCLE = 14,
	MO_FADE = 59,
	MO_FONT = 26,
	MO_LAYOUT = 60,
	MO_SCROLL = 61,
	MO_SQUARE = 44,
	MO_STREAMINGTEXT = 62,
	MO_TEXT = 46,
	MO_TRIANGLE = 51,
	MO_ELLIPSE = 22,
	MO_LINE = 74,
	MO_POLYGON = 34,
	MO_CURVE = 72,
	MO_A_2DAPPEARANCE = 73,
	MO_AMBIENTLIGHT = 8,
	MO_BACKGROUND = 11,
	MO_BILLBOARD = 12,
	MO_BOX = 13,
	MO_COLLISION = 15,
	MO_CONE = 17,
	MO_COORDINATE = 18,
	MO_CYLINDER = 19,
	MO_DIRECTIONALLIGHT = 20,
	MO_ELEVATIONGRID = 21,
	MO_EXTRUSION = 24,
	MO_GROUP = 27,
	MO_INLINE = 31,
	MO_LOD = 32,
	MO_NORMAL = 36,
	MO_POINTLIGHT = 37,
	MO_SOUND = 41,
	MO_SPHERE = 42,
	MO_SPOTLIGHT = 43,
	MO_TRANSFORM = 50,
	MO_VIEWPOINT = 52,
	MO_A_2DINDEXEDFACESET = 3,
	MO_INDEXEDFACESET = 29,
	MO_AUDIOMIX = 65,
	MO_AUDIBLE = 63,
	MO_AUDIOLOCALIZER = 64,
	MO_AUDIOSWITCH = 66,
	MO_AUDIOTONECONTROL = 67,
	MO_AUDIOTRANSFORM = 68,
	MO_NATURALAUDIO = 69,
	MO_STRUCTUREDAUDIO = 70,
	MO_TTSAUDIO = 71,
	MO_TOUCHSENSOR = 75,
	MO_PROXIMITYSENSOR = 76,
	MO_COLLISIONSENSOR = 77,
	MO_COLORINTERPOLATOR = 78,
	MO_COORDINATEINTERPOLATOR = 79,
	MO_NORMALINTERPOLATOR = 80,
	MO_ORIENTATIONINTERPOLATOR = 81,
	MO_POSITIONINTERPOLATOR = 82,
	MO_SCALARINTERPOLATOR = 83,
	MO_CONDITIONAL = 84,
	MO_TOTAL = 85
};

#endif                                      // _NodeIDs_h sentry.
