/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Parser
FILE:       NodeTabl.cpp
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Definition of node table (each node type has a table)
-------------------------------------------------------------------------*/
#include "defs.h"
#include "NodeFld.h"
#include "NodeIDs.h"

const int SF3DNode :: m_nodeTable [] =
{
	MO_QUANTIZATIONPARAMETER,
	MO_TOUCHSENSOR,
	MO_BILLBOARD,
	MO_INLINE,
	MO_LOD,
	MO_TRANSFORM,
	MO_AMBIENTLIGHT,
	MO_BACKGROUND,
	MO_DIRECTIONALLIGHT,
	MO_LISTENINGPOINT,
	MO_POINTLIGHT,
	MO_SHAPE,
	MO_SOUND,
	MO_SPOTLIGHT,
	MO_VIEWPOINT,
	MO_COLLISION,
};

const int SF2DNode :: m_nodeTable [] =
{
	MO_QUANTIZATIONPARAMETER,
	MO_SWITCH,
	MO_TOUCHSENSOR,
	MO_INLINE2D,
	MO_LAYOUT,
	MO_LOD2D,
	MO_SCROLL,
	MO_TRANSFORM2D,
	MO_XLAYOUT,
	MO_BACKGROUND2D,
	MO_IMAGE2D,
	MO_MOVIE2D,
	MO_SHAPE2D,
	MO_SOUND2D,
	MO_PROXIMITY2DSENSOR,
};

const int SFGeometry2DNode :: m_nodeTable [] =
{
	MO_CIRCLE,
	MO_CURVE2D,
	//	MO_INDEXEDFACESET2D  ???? SEEMS AN ERROR IN BIFS TABLES,
	MO_INDEXEDLINESET2D,
	MO_POINTSET2D,
	MO_RECTANGLE,
	MO_STREAMINGTEXT,
	MO_TEXT2D,
};

const int SFGeometryNode :: m_nodeTable [] =
{
	MO_BOX,
	MO_CONE,
	MO_CYLINDER,
	MO_ELEVATIONGRID,
	MO_EXTRUSION,
	MO_INDEXEDFACESET,
	MO_INDEXEDLINESET,
	MO_POINTSET,
	MO_SPHERE,
};

const int SFLayerNode :: m_nodeTable [] =
{
};

const int SFAudioNode :: m_nodeTable [] =
{
	MO_AUDIODELAY,
	MO_AUDIOMIX,
	MO_AUDIOSOURCE,
	MO_AUDIOTRANSFORM,
	MO_AUDIOSWITCH,
};

const int SFTextureNode :: m_nodeTable [] =
{
	MO_M4IMAGETEXTURE,
};

const int SFRootNode :: m_nodeTable [] =
{
	MO_GROUP2D,
	MO_GROUP,
};

const int SFBehaviorNode :: m_nodeTable [] =
{
	MO_ANIMATIONSTREAM,
	MO_COLORINTERPOLATOR,
	MO_CONDITIONAL,
	MO_SCALARINTERPOLATOR,
	MO_TIMESENSOR,
};

const int SFBehavior2DNode :: m_nodeTable [] =
{
	MO_COLORINTERPOLATOR,
	MO_CONDITIONAL,
	MO_SCALARINTERPOLATOR,
	MO_TIMESENSOR,
	MO_POSITION2DINTERPOLATOR,
};