//{{AFX_all

/* This file is automatically generated by bpcpp, written by Yuval Fisher */

#if !defined(_Nodes_h)  // Sentry, use file only if it's not already included.
#define _Nodes_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS Decoder/ Compositor / Presenters
FILE:       Nodes.h
AUTHOR:     bpcpp, by Yuval Fisher (Rockwell Science Center), 
Following Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Declarations of MediaObject objects. Should be used as a
template for the Presenter's developers.
-------------------------------------------------------------------------*/
#include "StreamCo.h"
#include "NodeFld.h"
#include "bifs.h"
#include "Group.h"

//}}AFX_top
// Gentle user: place private declarations here
class BIFSDecoder;
//{{AFX_top

/************ Transform2D ********************/
class Transform2D : public GroupNode
{
	 BIFS_DECLARE_NODE

//}}AFX_A_2DTransform
// Gentle user: place your variables here 
	friend BIFSDecoder;
	virtual BOOL Render (void *);  // Remove comment if implemented.
//{{AFX_A_2DTransform

protected:
	 SF<Vec2f> center;
	 MFGenericNode children;
	 SF<Rotation2D> rotation;
	 SF<Vec2f> scale;
	 SF<Rotation2D> scaleOrientation;
	 SF<Vec3f> translation;
	 SF<int> totalFrames;
	 SF<Time> currentTime;
	 void OncurrentTime ();
public:
	 Transform2D () : 
		 scale (Vec2f(1,1))
	{}
};

/************ Shape ********************/
class Shape : public MediaObject
{
	 BIFS_DECLARE_NODE

//}}AFX_Shape
// Gentle user: place your variables here 
	friend BIFSDecoder;
	virtual BOOL Render (void *);  // Remove comment if implemented.
//{{AFX_Shape

protected:
	 SFNode<class Appearance> appearance;
	 SFGeometryNode geometry;
public:
};

//}}AFX_
/*-----------------------------------------------------------------
A base object for all nodes with visual streaming. For simulation 
only.
-----------------------------------------------------------------*/
class StreamingVideo : public StreamConsumer
{
	DWORD m_dwStart;

private:
	virtual BOOL Render (void *);

protected:
	 SF<int> totalFrames;
	 SF<Time> currentTime;

public:
};
//{{AFX_

/************ MovieTexture ********************/
class MovieTexture : public StreamingVideo
{
	 BIFS_DECLARE_NODE

//}}AFX_MovieTexture
// Gentle user: place your variables here 
	friend BIFSDecoder;
// virtual BOOL Render (void *);  // Remove comment if implemented.
//{{AFX_MovieTexture

protected:
	 SF<Bool> loop;
	 SF<float> speed;
	 SF<Bool> repeatS;
	 SF<Bool> repeatT;
public:
	 MovieTexture () : 
		 loop (FALSE),
		 speed (1)
	{}
};

/************ Square ********************/
class Square : public MediaObject
{
	 BIFS_DECLARE_NODE

//}}AFX_Square
// Gentle user: place your variables here 
	friend BIFSDecoder;
// virtual BOOL Render (void *);  // Remove comment if implemented.
//{{AFX_Square

protected:
	 SF<Vec2f> size;
public:
	 Square () : 
		 size (Vec2f(2,2))
	{}
};

/************ Sound ********************/
class Sound : public MediaObject
{
	 BIFS_DECLARE_NODE

//}}AFX_Sound
// Gentle user: place your variables here 
	friend BIFSDecoder;
	virtual BOOL Render (void *);  // Remove comment if implemented.
//{{AFX_Sound

protected:
	 SF<Vec3f> direction;
	 SF<float> intensity;
	 SF<Vec3f> location;
	 SF<float> maxBack;
	 SF<float> maxFront;
	 SF<float> minBack;
	 SF<float> minFront;
	 SF<float> priority;
	 SFGenericNode source;
	 SF<Bool> spatialize;
public:
	 Sound () : 
		 direction (Vec3f(0,0,1)),
		 intensity (1),
		 maxBack (10),
		 maxFront (10),
		 minBack (1),
		 minFront (1),
		 spatialize (Bool(TRUE))
	{}
};

/************ NaturalAudio ********************/
class NaturalAudio : public StreamConsumer
{
	 BIFS_DECLARE_NODE

//}}AFX_NaturalAudio
// Gentle user: place your variables here 
	friend BIFSDecoder;
	virtual BOOL Render (void *);  // Remove comment if implemented.
	DWORD m_dwTime;
	int m_nSamples;
//{{AFX_NaturalAudio

public:
	 NaturalAudio () : 
		 m_nSamples (0)
	{}
};

/************ Font ********************/
class Font : public MediaObject
{
	 BIFS_DECLARE_NODE

//}}AFX_Font
// Gentle user: place your variables here 
	friend BIFSDecoder;
	virtual BOOL Render (void *);  // Remove comment if implemented.
//{{AFX_Font

protected:
//	 MFGenericNode children;
	 SFString type;
	 SF<Byte> style;
	 SF<int> size;
	 SF<int> hSpacing;
	 SF<int> vSpacing;
	 SFString language;
public:
	 Font () : 
		 type (""),
		 style (0),
		 size (-1),
		 hSpacing (100),
		 vSpacing (100),
		 language ("")
	{}
};

/************ StreamingText ********************/
class StreamingText : public StreamingVideo
{
	 BIFS_DECLARE_NODE

//}}AFX_StreamingText
// Gentle user: place your variables here 
	friend BIFSDecoder;
// virtual BOOL Render (void *);  // Remove comment if implemented.
//{{AFX_StreamingText

protected:
	 SF<int> maxSize;
	 SF<Bool> ucs_2;
	 SFGenericNode font;
public:
	 StreamingText () : 
		 maxSize (-1)
	{}
};

/************ Layout ********************/
 class Layout : public GroupNode
 {
	 BIFS_DECLARE_NODE

 //}}AFX_Layout
 // Gentle user: place your variables here 
	virtual BOOL Render (void *);  // Remove comment if implemented.
 //{{AFX_Layout

 protected:
	 MFGenericNode children;
	 SF<Byte> mode;
	 SF<Bool> wrap;
	 SF<int> width;
	 SF<int> height;
 public:
	 Layout () :  
		 mode (0),
		 wrap (0),
		 width (-1),
		 height (-1)
	 { 
		 //}}AFX_Layout
		 // Place extra variable initializations here
		 //{{AFX_Layout
	 }
 };

/************ Normal ********************/
class Normal : public MediaObject
{
	 BIFS_DECLARE_NODE

//}}AFX_Normal
// Gentle user: place your variables here 
	friend BIFSDecoder;
// virtual BOOL Render (void *);  // Remove comment if implemented.
//{{AFX_Normal

protected:
	 MF<Vec3f> vector;
};

/************ Appearance ********************/
class Appearance : public MediaObject
{
	 BIFS_DECLARE_NODE

//}}AFX_Appearance
// Gentle user: place your variables here 
public:
	virtual BOOL Render (void * = NULL);  // Remove comment if implemented.
//{{AFX_Appearance

protected:
	 SFGenericNode material;
	 SFGenericNode texture;
	 SFGenericNode textureTransform;
public:
	 Appearance () 
	 { 
		 //}}AFX_Appearance
		 // Place extra variable initializations here
		 //{{AFX_Appearance
	 }
};

//}}AFX wizard generated definitions
#include "CrNodes.h"

//{{AFX
#endif                                     // _Nodes_h sentry.
//}}AFX_all
