#if !defined(_pcmdec_h)	// Sentry, use file only if it's not already included.
#define _pcmdec_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Decoder
FILE:       PCMDec.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Definition of PCMDecoder
-------------------------------------------------------------------------*/
#include "Decoder.h"

class PCMDecoder : public Decoder
{
	int m_nSamples;

	virtual FORMAT SetFormat (Capabilities *pPresentationCapabilities);
	virtual int GetOptimalInputSize () {return 481;}
	virtual int GetOptimalOutputSize () {return 480;}
	virtual int GetRecommendedInputBufferSize () {return 2000;}
	virtual int GetRecommendedOutputBufferSize () {return 960;}
	virtual BOOL Decode (
		LPBYTE pInput,
		int nInputLength,
		LPBYTE pOutput,
		int &rnOutputLength
	);
	virtual void Run ();

public:
	PCMDecoder (class Executive *pExecutive) : Decoder (pExecutive) {}
};

#endif                                      // _pcmdec_h sentry.
