/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS Decoder/ Compositor
FILE:       Quantize.cpp
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Implementation of Quantizer
-------------------------------------------------------------------------*/

#include "defs.h"
#include <float.h>
#include "Quantize.h"
#include "BifsDec.h"
#include "ztl.h"

/*-----------------------------------------------------------------
Parse an int from the BIFS stream
-----------------------------------------------------------------*/
int Quantizer :: ParseInt (BIFSDecoder *pBifs)
{
	/*-----------------------------------------------------------------
	Determine offset and number of bits
	-----------------------------------------------------------------*/
	int nOffset = 0, nBits = 32;
	if (m_nDimension == 1 &&
		m_pMin [0] != FLT_MIN && m_pMax [0] != FLT_MAX
	)
	{	int min = m_pMin [0];
		int max = m_pMax [0];
		nBits = BitFieldWidth (max - min + 1);
		nOffset = min;
	}
	return pBifs -> ParseInt (nBits) + nOffset;
}