#if !defined(_Quantize_h)	// Sentry, use file only if it's not already included.
#define _Quantize_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS Decoder/ Compositor
FILE:       Quantize.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Declarations of Quantizer
-------------------------------------------------------------------------*/

class BIFSDecoder;

#ifdef BIFSENC
class BIFSEncoder;
#endif

class Quantizer
{
	const float *m_pMin, *m_pMax;
	int m_nDimension, m_nQuantizationCode;

public:
	Quantizer (
		const float *pMin,  
		const float *pMax,  
		int nDimension = 1, 
		int nQuantizationCode = 0
	) :
		m_pMin (pMin),
		m_pMax (pMax),
		m_nDimension (nDimension),
		m_nQuantizationCode (nQuantizationCode)
	{}
	int ParseInt (BIFSDecoder *pBifs);

#ifdef BIFSENC
public:
	void EncodeInt (BIFSEncoder *pBifs, int nValue);
#endif // BIFSENC
};

#endif                                      // _Quantize_h sentry.
