#if !defined(_root_h)	// Sentry, use file only if it's not already included.
#define _root_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS Decoder/ Compositor / Presenter
FILE:       Root.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Declarations of a base class for root nodes
-------------------------------------------------------------------------*/
#include "Group.h"
#include "ztl.h"
#include "NodeFld.h"
#include "WrldInfo.h"
#include "StrAssoc.h"

class Root : public GroupNode
{
	ZArray<MediaObject *> m_nodes;
	ZArray<Route *> m_routes;
	SFNode<WorldInfo> m_worldInfo;
	SFNode<SessionStreamAssociation> m_streamAssociation;

public:
#ifndef BIFSENC
	Root () {m_bIsRoot = TRUE;}
	BOOL ReplaceRoute (int nRouteID,  BIFSDecoder *pBifs);
	BOOL DeleteRoute (int nRouteID);
	BOOL ReplaceNode (int nNodeID,  BIFSDecoder *pBifs);
	BOOL DeleteNode (int nNodeID);
	Route * FindRoute  (int nID);
	MediaObject * FindNode  (int nID);
	void UnregisterRoute (Route *pRoute) {m_routes -= pRoute;}
	void RegisterRoute (Route *pRoute) {m_routes += pRoute;}
	void UnregisterNode (MediaObject *pNode) {m_nodes -= pNode;}
	void RegisterNode (MediaObject *pNode) {m_nodes += pNode;}
	void SetWorldInfo (WorldInfo *pNode) {m_worldInfo = pNode;}
	WorldInfo *GetWorldInfo () {return m_worldInfo;}
	void SetSessionStreamAssociation (SessionStreamAssociation *pNode)
	{
		m_streamAssociation = pNode;
	}
	SessionStreamAssociation *GetSessionStreamAssociation ()
	{
		return m_streamAssociation;
	}

	CUSTOMIZE_ROOT_DECLARATION
#endif
};

#endif                                      // _root_h sentry.
