#if !defined(_StrAssoc_h)  // Sentry, use file only if it's not already included.
#define _StrAssoc_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  BIFS Decoder/ Compositor / Presenters
FILE:       StrAssoc.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Declaration of a SessionStreamAssociation class.
-------------------------------------------------------------------------*/
#include "bifs.h"
#include "NodeFld.h"
#include "Group.h"

class SessionStreamAssociation : public GroupNode
{
	BIFS_DECLARE_NODE

	MFNode<class ObjectDescriptor> children;

#ifndef BIFSENC
public:
	void SetStreams ();
#endif	// BIFSENC
};

class ObjectDescriptor : public MediaObject
{
	BIFS_DECLARE_NODE

	SFObjectID objectDescriptorID;
	SFString decTypeString;
	SF<int> configParam;
	SFString fileName;

#ifndef BIFSENC
public:
	void SetStream ();
#endif	// BIFSENC
};

#include "CrNodes.h"

#endif	// _StrAssoc_h sentry