#if !defined(_JPEG_h)  // Sentry, use file only if it's not already included.
#define _JPEG_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       JPEG.h
AUTHOR:     Matthew Leditschke (CSELT)
OVERVIEW:   Declaration of JPEGStream, the class that handles JPEG streams
-------------------------------------------------------------------------*/
#include "Stream.h"

class JPEGStream : public Stream
{
	BOOL m_constant;
	float m_nextTime;
	float m_intervalTime;
	FILE* m_timeFile;
	float m_prevTime[2];
	int m_prevChar[2];
	int m_nextChar;
	int m_readAhead;

public:
	JPEGStream (FILE *fStream, const char* streamData);
	~JPEGStream ();
	virtual long GetTimeStamp ();
	virtual int GetChar ();
};

#endif	// _JPEG_h sentry