#if !defined(_MuxOD_h)  // Sentry, use file only if it's not already included.
#define _MuxOD_h

/*-------------------------------------------------------------------------
Project Im1Player
INTERNATIONAL ORGANIZATION FOR STANDARDIZATION
ISO/IEC JTC1/SC29/WG11

SUBSYSTEM:  Multiplexer
FILE:       MuxOD.h
AUTHOR:     Zvi Lifshitz (VDOnet Corp.)
OVERVIEW:   Declaration of MuxObjectDescriptor
-------------------------------------------------------------------------*/
#include "NodeFld.h"
#include "Bifs.h"

class StreamFactoryBase;
class Stream;

class MuxObjectDescriptor : public MediaObject
{
	BIFS_DECLARE_NODE

	SFObjectID objectDescriptorID;
	SFString decTypeString;
	SF<int> configParam;
	SF<Time> startTime;
	SFString fileName;
	SFString streamData;
	FILE *m_fStream, *m_fMP4;
	Stream *m_pStream;
	long m_lTS;
	ESCONFIGPARAMS *m_pConfigParams;
	int m_nHeaderLength, m_nSequenceNumber, m_nFMC;
	int m_bLastByte, m_nBitCount;
	BYTE m_header [30];
	static StreamFactoryBase *m_pFactories [40];
	static int m_nFactoriesAvailable;

private:
	void FlushHeader ();
	void StoreHeaderBits (int nValue, int nLength);
	void StorePacket (LPBYTE packet, int nPacketLength);
	void PrepareHeader (BOOL bStart, BOOL bEnd);

public:
	MuxObjectDescriptor () : m_fStream (NULL), m_pStream (NULL) {}
	~MuxObjectDescriptor ();
	BOOL operator == (const MuxObjectDescriptor &) const {return FALSE;}
	BOOL Parse (FILE *fMP4, int nFMC);
	long GetTimeStamp ();
	long GetStartTime () {return startTime;}
	void Store ();
	static void RegisterFactory (StreamFactoryBase *pFactory);
	int GetODid () {return objectDescriptorID;}
};

#endif	// _MuxOD_h sentry